# lisp versions and release
%if 0%{?fedora} == 11
%define cmucl_ver  19f
%define sbcl_ver   1.0.30
%define clisp_ver  2.47
%endif
%if 0%{?fedora} == 10
%define cmucl_ver  19e
%define sbcl_ver   1.0.30
%define clisp_ver  2.47
%endif
%if 0%{?fedora} == 9
%define cmucl_ver  19e
%define sbcl_ver   1.0.22
%define clisp_ver  2.47
%endif
%if 0%{?fedora} == 8
%define cmucl_ver  19e
%define sbcl_ver   1.0.22
%define clisp_ver  2.43
%endif
%if 0%{?fedora} == 7
%define cmucl_ver  19d
%define sbcl_ver   1.0.13
%define clisp_ver  2.43
%endif
%if 0%{?fedora} == 6
%define cmucl_ver  19c
%define sbcl_ver   1.0.9
%define clisp_ver  2.41
%endif
%if 0%{?rhel} == 5
%define cmucl_ver  19d
%define sbcl_ver   1.0.30
%define clisp_ver  2.43
%endif

%ifarch x86_64
%define cmucl_build 0
%else
%define cmucl_build 1
%endif
%define sbcl_build  1
%define clisp_build 1

%define cvsdate 2008-12-07
%define cvsrel %(echo %{cvsdate}|sed 's/-//g')

Summary: Superior Lisp Interaction Mode for Emacs
Name: slime
Version: 2.0
Release: 16%{?cvsdate:.%{cvsrel}.1}%{?dist}
License: GPL
Group: Development/Languages
URL: http://common-lisp.net/project/slime/
Source0: slime-%{?cvsdate:%{cvsdate}}%{!?cvsdate:%{version}}.tgz
Patch0: slime-cvs-swank-loader.patch
Patch1: slime-cvs-swank-loader-build.patch
Patch2: slime-cvs-doc-makefile.patch
Patch3: slime-sbcl-sigio.patch
Patch4: slime-cvs-swank-loader-x86_64.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Packager: Fernando Lopez-Lezcano
Vendor: Planet CCRMA
Distribution: Planet CCRMA

%if 0%{?fedora} > 9
%define texsystem texlive
%else
%define texsystem tetex
%endif

%if "%{cmucl_build}" == "1"
BuildRequires: cmucl = %{cmucl_ver}
%endif
%if "%{sbcl_build}" == "1"
BuildRequires: sbcl = %{sbcl_ver}
%endif
%if "%{clisp_build}" == "1"
BuildRequires: clisp = %{clisp_ver}
%endif
%if 0%{?fedora} > 8
BuildRequires: texlive texlive-latex texlive-dvips dvipdfm
%else
BuildRequires: tetex tetex-latex tetex-dvips
%endif
%if 0%{?fedora} >= 6 || 0%{?rhel} >= 5
BuildRequires: texinfo texinfo-tex
%endif

%description
SLIME is the Superior Lisp Interaction Mode for Emacs. This is an
ILISP-like development environment intended for maximum integration
with CMUCL (also works with SBCL, OpenMCL and work is ongoing on
Lispworks and current CVS version of CLISP and CLISP 2.32 on Linux).

%package cmucl
Summary: Slime binaries for CMUCL
Group: Development/Languages
Requires: cmucl = %{cmucl_ver}
Requires: slime = %{version}-%{release}

%description cmucl
Slime binaries for CMUCL

%package sbcl
Summary: Slime binaries for SBCL
Group: Development/Languages
Requires: sbcl = %{sbcl_ver}
Requires: slime = %{version}-%{release}

%description sbcl
Slime binaries for SBCL

%package clisp
Summary: Slime binaries for Clisp
Group: Development/Languages
Requires: clisp = %{clisp_ver}
Requires: slime = %{version}-%{release}

%description clisp
Slime binaries for Clisp

%prep
%setup -q -n slime-%{?cvsdate:%{cvsdate}}%{!?cvsdate:%{version}}
# patch swank-loader to put fasl files in place
%patch1 -p1
# doc makefile patch
%patch2 -p1
# change default communication style in threaded sbcl to :sigio
%if 0%{?fedora} == 4
%patch3 -p1
%endif

%build
%if "%{cmucl_build}" == "1"
/usr/bin/lisp <<EOF
(in-package :cl-user)
(load "swank-loader.lisp")
(swank-loader::loadup)
(quit)
EOF
%endif

%if "%{sbcl_build}" == "1"
/usr/bin/sbcl <<EOF
(in-package :cl-user)
(load "swank-loader.lisp")
(swank-loader::loadup)
(quit)
EOF
%endif

%if "%{clisp_build}" == "1"
/usr/bin/clisp <<EOF
(in-package :cl-user)
(load "swank-loader.lisp")
(swank-loader::loadup)
(in-package :cl-user)
(bye)
EOF
%endif

# create documentation
cd doc
# the make target does not work
# create pdf and ps targets
make contributors.texi
texi2dvi slime.texi
dvipdfm slime.dvi
dvips -o slime.ps slime.dvi

%install
%{__rm} -rf %{buildroot}
%{__mkdir} -p %{buildroot}%{_datadir}

%{__mkdir} -p %{buildroot}%{_libdir}/slime
%{__mv} fasl %{buildroot}%{_libdir}/slime

# patch swank-loader for runtime load of prebuilt binaries
cd %{buildroot}%{_datadir}
%{__tar} xzpf %{SOURCE0}
%{__mv} slime-%{?cvsdate:%{cvsdate}}%{!?cvsdate:%{version}} slime
cd slime
%ifnarch x86_64
%{__patch} -p1 <%{PATCH0}
%else
%{__patch} -p1 <%{PATCH4}
%endif

%clean
%{__rm} -rf %{buildroot}


%files
%defattr(-,root,root,-)
%doc HACKING NEWS PROBLEMS README
%doc doc/slime.ps doc/slime.pdf doc/slime-refcard.pdf doc/slime-small.pdf
%{_datadir}/slime

%if "%{cmucl_build}" == "1"
%files cmucl
%defattr(-,root,root,-)
%{_libdir}/slime/fasl/*/cmu*
%endif

%if "%{sbcl_build}" == "1"
%files sbcl
%defattr(-,root,root,-)
%{_libdir}/slime/fasl/*/sbcl*
%endif

%if "%{clisp_build}" == "1"
%files clisp
%defattr(-,root,root,-)
%{_libdir}/slime/fasl/*/clisp*
%endif

%changelog
* Wed Sep  2 2009 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.0-16
- updated lisp versions for Fedora 10/11

* Thu Jun 11 2009 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- updated lisp versions for Fedora 11

* Wed Dec 10 2008 Arnaud Gomes-do-Vale <Arnaud.Gomes@ircam.fr>
- update sbcl version for CentOS 5 to 1.0.22 (now in EPEL)

* Mon Dec  8 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.0-15.20081207.1
- updated to current cvs snapshot of slime (previous is no longer
  compatible with sbcl 1.0.22)
- make pdf manual by hand (make does not seem to work), also include
  prebuild reference card and small manual

* Mon Dec  1 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.0-14
- update sbcl version for Fedora 10

* Mon Dec  1 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- updated sbcl version for Fedora 8 to 1.0.22 (same for x86_64 in fc9)

* Wed Nov 26 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.0-13
- updated lisp versions on fc9, rebuild

* Tue Nov 25 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- added support for fc10 builds

* Fri Jul  4 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.0-12
- rebuild on fc8/9 for new sbcl 1.0.17 and cmucl 19e

* Wed May 14 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- added proper tex dependencies for fc9 (texlive instead of tetex),
  added dvipdfmx
- added fc9 lisp versioning information

* Fri Feb  1 2008 Arnaud Gomes-do-Vale <Arnaud.Gomes@ircam.fr>
- build on CentOS

* Fri Jan 18 2008 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.0-11
- rebuild for sbcl 1.0.13 and clisp 2.43 on f7/f8

* Wed Nov 14 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.0-10
- rebuild for sbcl 1.0.10 on f8

* Tue Sep  4 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.0-9
- rebuild for sbcl 1.0.9

* Mon Jun 11 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.0-8
- rebuild for sbcl 1.0.6

* Tue May  8 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- added fc7 version dependencies

* Mon Apr 23 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.0-7
- rebuild on fc5 for new sbcl 1.0.4-1.1

* Mon Apr  2 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.0-7
- rebuild for sbcl 1.0.4-1.1 (with threading enabled)

* Wed Mar 28 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.0-6
- rebuild for sbcl 1.0.4

* Fri Mar 16 2007 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.0-5
- rebuild on fc6 for sbcl=1.0.2

* Thu Dec 12 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.0-4
- rebuild on fc6 for sbcl=1.0

* Wed Nov 29 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.0-3
- rebuild for fc6, tweak patch0 for x86_64 (/usr/lib64...), save
  as patch4 and apply depending on build architecture

* Thu Sep  7 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.0-2
- rebuild on fc5 for newer lisp versions

* Sat Jun 24 2006 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 2.0-1
- updated to 2.0-1
- redid patches for building, file lists

* Sat Dec 17 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.2.1-2.3.cvs
- changed communication style of threaded sbcl to sigio, otherwise there
  are problems with the realtime scheduler in common music (kills lisp if
  run), sigio appears to work fine. 

* Wed Dec 14 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.2.1-2.2.cvs
- cvs snapshot dated 2005.12.14
  to download cvs:
  export CVSROOT=:pserver:anonymous@common-lisp.net:/project/slime/cvsroot
  cvs login
  (password=anonymous)
  cvs checkout slime

* Sat Dec 10 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.2.1-2.1.cvs
- rebuilt for sbcl 0.9.7 and cmucl 2005.12

* Sat Dec  3 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.2.1-2.0.cvs
- updated to cvs snapshot, 1.2.1 does not compile with sbcl 0.9.6

* Sat Nov 12 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.2.1-2
- rebuild for new sbcl/cmucl/clisp versions

* Tue Aug 16 2005 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.2.1-1
- updated to 1.2.1, updated swank patches
- do not build for clisp on fc4
- replaced texi2pdf with dvipdfm (fc4 does not include texi2pdf

* Wed Dec 29 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- spec file cleanup

* Mon Nov  8 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 
- added documentation build

* Sun Nov  7 2004 Fernando Lopez-Lezcano <nando@ccrma.stanford.edu> 1.0-1
- initial build.
